/*BK battery charge monitor for the notification tray*/
/*(c) Copyright Barry Kauler 2010, bkhome.org*/
/*GPL license: /usr/share/doc/legal/gpl-2.0.txt*/
/*100517 BK only blink icon if not charging...*/
/*101003 rewritten for XO-1 ,1.5, 01micko ..simplified*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <glib/gstdio.h>

#include "emptychg.xpm"
#include "twentychg.xpm"
#include "fortychg.xpm"
#include "sixtychg.xpm"
#include "eightychg.xpm"
#include "fullchg.xpm"

GdkPixbuf *emptychg_pixbuf;
GdkPixbuf *twentychg_pixbuf;
GdkPixbuf *fortychg_pixbuf;
GdkPixbuf *sixtychg_pixbuf;
GdkPixbuf *eightychg_pixbuf;
GdkPixbuf *fullchg_pixbuf;

GtkStatusIcon *tray_icon;
unsigned int interval = 45000; /*update interval in milliseconds*/
int batpercent = 97;
char inbuf[4];
FILE *fp;
char memdisplaylong[64];
char filename1[80]="/sys/devices/platform/olpc-battery.0/power_supply/olpc-battery/capacity";

gboolean Update(gpointer ptr);

gboolean Update(gpointer ptr) {
    char strpercent[4];
   
		fp = fopen(filename1,"r");
		if(fp == NULL)
		{
		printf("can't open file\n");
		return;
		}
		while(!feof(fp))      
		{
		fscanf(fp,"%3s",strpercent);
		batpercent=atoi(strpercent);
		}
        fclose(fp);
	
    //update icon... For XO I think this can stay the same
    //if (gtk_status_icon_get_blinking(tray_icon)==TRUE) gtk_status_icon_set_blinking(tray_icon,FALSE);
    /*if (chargestat ==  Full || chargestat ==  Charging) {*/
        if (batpercent < 15) gtk_status_icon_set_from_pixbuf(tray_icon,emptychg_pixbuf);
        else if (batpercent < 21) gtk_status_icon_set_from_pixbuf(tray_icon,twentychg_pixbuf);
        else if (batpercent < 41) gtk_status_icon_set_from_pixbuf(tray_icon,fortychg_pixbuf);
        else if (batpercent < 61) gtk_status_icon_set_from_pixbuf(tray_icon,sixtychg_pixbuf);
        else if (batpercent < 81) gtk_status_icon_set_from_pixbuf(tray_icon,eightychg_pixbuf);
        else gtk_status_icon_set_from_pixbuf(tray_icon,fullchg_pixbuf);
    
   
    
    //update tooltip...
    memdisplaylong[0]=0;
    strcat(memdisplaylong,"Battery ");
    char batdisplay[3];
    sprintf(batdisplay,"%d",batpercent);
    strcat(memdisplaylong,batdisplay);
    //printf("%d \n",chargestat);
    strcat(memdisplaylong,"%");
    gtk_status_icon_set_tooltip(tray_icon, memdisplaylong);
}

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data)
{
    //printf("Clicked on tray icon\n"); this changed for XO
	    system("/usr/X11R7/bin/yaf-splash -display :0 -margin 2 -bg thistle -bw 0 -placement center -font \"-misc-dejavu sans-bold-r-normal--16-0-0-0-p-0-iso10646-1\" -outline 0 -text \"`cat /sys/devices/platform/olpc-battery.0/power_supply/olpc-battery/uevent`\" & ");
        //else system("yaf-splash -display :0 -margin 2 -bg thistle -bw 0 -placement center -font "-misc-dejavu sans-bold-r-normal--16-0-0-0-p-0-iso10646-1" -outline 0 -text \"`cat /proc/acpi/battery/BAT1/info /proc/acpi/battery/BAT1/state | sort -u`\" & ");
 }   


void tray_icon_on_menu(GtkStatusIcon *status_icon, guint button, guint activate_time, gpointer user_data)
{
    printf("Popup menu\n");
}

static GtkStatusIcon *create_tray_icon() {

    tray_icon = gtk_status_icon_new();
    g_signal_connect(G_OBJECT(tray_icon), "activate", G_CALLBACK(tray_icon_on_click), NULL);
    g_signal_connect(G_OBJECT(tray_icon), "popup-menu", G_CALLBACK(tray_icon_on_menu), NULL);

    
    //blank_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)blank_xpm); //maybe should leave, undecided
    emptychg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)emptychg_xpm);
    twentychg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)twentychg_xpm);
    fortychg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)fortychg_xpm);
    sixtychg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)sixtychg_xpm);
    eightychg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)eightychg_xpm);
    fullchg_pixbuf=gdk_pixbuf_new_from_xpm_data((const char**)fullchg_xpm);

    gtk_status_icon_set_tooltip(tray_icon, "Battery charge");
    gtk_status_icon_set_visible(tray_icon, TRUE);

    return tray_icon;
}

int main(int argc, char **argv) {
	
    //olpc?
    if((fp = fopen(filename1, "r")) == NULL){
        printf("Sorry, can't open %s", filename1);
       }
       
   /* if((pfile = fopen(filename2, "r")) == NULL){
        printf("Sorry, can't open %s", filename2);
       }  */
     

    GtkStatusIcon *tray_icon;

    gtk_init(&argc, &argv);
    tray_icon = create_tray_icon();
    
    gtk_timeout_add(interval, Update, NULL);
    Update(NULL);

    gtk_main();

    return 0;
}
